/**
 * 事业部项目表动态list.js
 */
shr.defineClass("shr.custom.BusDepProjectDynamicList", shr.custom.CustomDynamicList, {
	//可编辑列 数组(不区分大小写)
	editColumns: [],
	isSum: false,
	initalizeDOM: function () {
		//新增编辑列
		this.editColumns.push("principal.name");
		this.editColumns.push("bdp.notprincipalpropor");
		this.editColumns.push("bdp.bonusAmount");
		this.editColumns.push("bdp.principalpropor");
		this.editColumns.push("bdp.totalbonushalf");
		this.editColumns.push("bdp.totalbonushalf");
		this.editColumns.push("bdp.totalbonusreal");
		this.editColumns.push("bdp.directmanprojbonus");
		this.editColumns.push("bdp.contramanprojbonus");
		this.editColumns.push("bdp.condmanprojectbonus");
		this.editColumns.push("bdp.stramanprojectbonus");
		this.editColumns.push("bdp.bonusadjustment");
		this.editColumns.push("bdp.bonusadjustmentdesc");
		this.editColumns.push("bdp.initialallocationratio1");
		this.editColumns.push("bdp.initialallocationratio2");
		this.editColumns.push("bdp.initialallocationratio3");
		shr.custom.BusDepProjectDynamicList.superClass.initalizeDOM.call(this);
	},
	/**
	 * 返回
	 */
	// backAction: function () {
	// 	var self = this;
	// 	shr.custom.BusDepProjectDynamicList.superClass.backAction.call(this,function(){
	// 		//跳转周期表
	// 		window.parent.location.href = "/shr/dynamic.do?uipk=com.kingdee.eas.custom.projectbonus.app.BonusCycle.list&inFrame=true";
	// 	});
	// },
	// 根据动态列表配置 取业务主键
	getBillIdFieldName: function () {
		return 'bdp.id';
	},
	//导出选中
	getExportFieldName: function () {
		return 'bdp.id';
	},
	/**
	* 描述: 维护奖金分配人员明细
	*/
	optionPersonnelDetailAction: function () {
		var self = this;
		//自定义参数
		var parentId = shr.getUrlParam('parentId');
		self.beforeSave();
		if (self.checkEditCell()) {
			shr.showConfirm("您有编辑数据未保存，是否忽略？", function () {
				self.reloadPage({
					uipk: "com.kingdee.eas.custom.projectbonus.app.PersonnelDetail.dynamicList",
					parentId: parentId
				});
			}, function () {
				return;
			});
		} else {
			self.reloadPage({
				uipk: "com.kingdee.eas.custom.projectbonus.app.PersonnelDetail.dynamicList",
				parentId: parentId
			});
		}
	},
	/**
	 * 描述: 导入action
	 */
	importAction: function () {
		var self = this;
		//自定义参数
		var parentId = shr.getUrlParam('parentId');
		var customParam = { "parentId": parentId }
		self.beforeSave();
		if (self.checkEditCell()) {
			shr.showConfirm("您有编辑数据未保存，是否忽略？", function () {
				self.doImportData('import', customParam);
			}, function () {
				return;
			});
		} else {
			self.doImportData('import', customParam);
		}
	},
	/**
	 * 同步事业部项目
	 */
	syncDepProjectAction: function () {
		var self = this;
		var parentId = shr.getUrlParam('parentId');
		var options = {
			action: 'syncDepProject',
			uipk: this.uipk,
			type: 'POST',
			param: {
				parentId: parentId
			},
			success: function (res) {
				//重新查询数据
				self.queryGrid();
				shr.showInfo({
					message: res,
					hideAfter: 3
				});
			},
		};
		self.beforeSave();
		if (self.checkEditCell()) {
			shr.showConfirm("您有编辑数据未保存，是否忽略？", function () {
				shr.remoteCall(options);
			}, function () {
				return;
			});
		} else {
			shr.remoteCall(options);
		}
	},
	/**
	 * 获得自定义过滤条件，供子类覆写使用
	 */
	getCustomFilterItems: function () {
		var parentId = shr.getUrlParam('parentId');
		return "bonusCycle.id = '" + parentId + "' and busdep.id is not null"
	},
	/**
	* 组装保存时传至服务端的数据
	*/
	assembleSaveData: function (action) {
		var _self = this;
		//组装需要修改的数据
		var data = [];
		var meta;
		var id, column, value, cur, element, personCode, datatype;
		var tds = $("#grid td[class*='dirty-cell']");
		var $table = $("#grid")[0];

		for (var i = 0; i < tds.length; i++) {
			//获取父节点，以获取对应id
			meta = {};
			var cur = $(tds[i]);
			//获取输入的内容，而不是转以后的字符实体，同时对单引号处理

			fid = cur.parent().attr('id');
			element = cur.attr('aria-describedby').replace('grid_', '');
			value = $($table).getCell(fid, element);
			//value = cur.text().replace(/\'/g, "''").trim();
			fid = cur.parent().attr('id');
			element = cur.attr('aria-describedby').replace('grid_', '');
			datatype = _self.getColumnType(element);
			if ("promptbox" == datatype) {
				column = element.split('.')[0];
				value = value["id"];
			} else {
				column = element.split('.')[1];
			}
			//列表需要显示id列
			id = $("#" + _self.getEscapeChars(fid) + " td[aria-describedby='grid_bdp\\.id']").attr('title');
			// //校验输入内容

			if (!_self.checkNumValid(value, datatype)) {
				$(tds[i]).focus();
				$(tds[i]).css({
					"border": "solid 2px red"
				});
				throw new Error("请输入正确的格式");
			}
			meta.fid = id;
			meta.column = column;
			meta.value = value;
			meta.type = datatype;
			data.push(meta);
		}
		return data;
	},
	/**
	 * 批量撤回
	 */
	batchWithdrawAction: function () {
		this.defaultBatchActionHandle("batchWithdraw");
	},
	/**
	 * 默认的action处理方法
	 */
	defaultBatchActionHandle: function (option) {
		var self = this;
		var selectedIds = this.getSelectedIds();
		if (!selectedIds) {
			shr.showWarning({ message: "请先选中数据!", hideAfter: 3 })
			return;
		}
		self.beforeSave();
		if (self.checkEditCell()) {
			shr.showConfirm("您有编辑数据未保存，是否忽略？", function () {
				shr.custom.BusDepProjectDynamicList.superClass.defaultBatchActionHandle.call(self, option);
			}, function () {
				return;
			});
		} else {
			shr.custom.BusDepProjectDynamicList.superClass.defaultBatchActionHandle.call(this, option);
		}
	},
	/**
	 * 解锁
	 */
	unlockAction: function () {
		var self = this;
		var parentId = shr.getUrlParam('parentId');
		self.remoteCall({
			method: "unlock",
			async: false,
			param: { parentId: parentId },
			success: function (res) {
				shr.showSuccess({
					message: "解锁成功!",
					hideAfter: 3
				});
				self.queryGrid();
			}
		});
	},
	/**
	 * 锁定
	 */
	lockAction: function () {
		var self = this;
		var parentId = shr.getUrlParam('parentId');
		self.remoteCall({
			method: "lock",
			async: false,
			param: { parentId: parentId },
			success: function (res) {
				shr.showSuccess({
					message: "锁定成功!",
					hideAfter: 3
				});
				_self.queryGrid();
			}
		});
	}
});

