/**
 * 分配人员明细动态list.js(负责人)
 */
shr.defineClass("shr.custom.DetailPrincipalDynamicList", shr.custom.CustomDynamicList, {
	//可编辑列 数组(不区分大小写)
	editColumns: [],
	isSum: false,
	initalizeDOM: function () {
		//新增编辑列
		this.editColumns.push("person.name");
		this.editColumns.push("bdpapd.functioncoefficient");
		this.editColumns.push("bdpapd.energyinputcoeff");
		this.editColumns.push("bdpapd.performancegradeq1");
		this.editColumns.push("bdpapd.performancegradeq2");
		this.editColumns.push("bdpapd.performancecoeffq1");
		this.editColumns.push("bdpapd.performancecoeffq2");
		this.editColumns.push("bdpapd.bonusduedate");
		this.editColumns.push("bdpapd.bonusstartingdate");
		this.editColumns.push("bdpapd.initialproportion");
		this.editColumns.push("bdpapd.adjustmentdesc");
		this.editColumns.push("bdpapd.opinionamount");
		shr.custom.DetailPrincipalDynamicList.superClass.initalizeDOM.call(this);
		this.setF7Attribute();
	},
	/**
	 * 设置F7组件属性
	 */
	setF7Attribute: function () {
		var self = this;
		//过滤事业部
		$('#busDep').shrPromptBox("option", {
			//确定按钮设置值,之后执行方法
			afterOK: function (datas, e) {
				//查询表格数据
				self.queryGrid();
			},
			//open方法里调用
			verifyBeforeOpenCallback: function (e, value) {
				var fliter = self.getBusdepFilter("adminOrg");
				$("#busDep").shrPromptBox("setFilter", "id in ( " + fliter + ")");
			}
		});
		//计算_事业部
		$('#calculateBusDep').shrPromptBox("option", {
			//确定按钮设置值,之后执行方法
			afterOK: function (datas, e) {
				//计算
				self.doCalculate();
			},
		});
		//提交_事业部
		$('#submitBusDep').shrPromptBox("option", {
			//确定按钮设置值,之后执行方法
			afterOK: function (datas, e) {
				//提交
				self.doSubmit();
			},
		});
		$("#grid").delegate(".ui-datepicker-layout", "keyup.datetimepicker click", function () {
			//奖金期限截止日期  奖金期限开始日期
			$("input[id$='_bdpapd.bonusduedate']").shrDateTimePicker('option', {
				onchange: function (e, val) {
					var info = val.current;
					var rowid = $($(e.target).parents('tr')[0]).attr('id');
					var personPosition = _self.getPersonPositionByPersonId(info["id"]);
					//填充组织、职位、任职id
					//$("#grid").wafGrid("setCell", rowid, "person.number", info["number"]);

				},
			});
		});




	},
	/**
	 * 	单元格点击事件触发
	 * @param {*} rowid 
	 * @param {*} colIndex 
	 * @param {*} cellcontent 
	 * @param {*} e 
	 * @returns 
	 */
	onCellSelect: function (rowid, colIndex, cellcontent, e) {
		shr.custom.DetailPrincipalDynamicList.superClass.onCellSelect.call(this);
		// 选择的是选择框
		if (colIndex != 0) {
			var state = $("#grid").jqGrid("getCell", rowid, "bdp.state");
			if (1 != state) {
				//非启用状态不能编辑
				$("#grid").jqGrid("setGridParam", { cellEdit: false })
			} else {
				//非启用状态不能编辑
				$("#grid").jqGrid("setGridParam", { cellEdit: true })
			}
			return;
		}
	},
	// 根据动态列表配置 取业务主键
	getBillIdFieldName: function () {
		return 'bdpapd.id';
	},

	/**
	 * 描述: 导入action
	 */
	importAction: function () {
		//自定义参数
		var parentId = shr.getUrlParam('parentId');
		var customParam = { "parentId": parentId }
		this.doImportData('import', customParam);
	},
	/**
	 * 表格加载完成后操作，供子类复写
	 */
	afterLoadComplete: function (ret) {
		//当状态非启用 编辑列单元格背景色显示白色
		if (ret.records > 0) {
			for (let i = 0; i < ret.rows.length; i++) {
				var rowData = ret.rows[i];
				var state = rowData["bdp.state"];
				if (1 != state.value) {
					//非启用状态
					var fid = rowData[this.getBillIdFieldName()];
					var tr = $('tr[id="' + fid + '"]')
					var tds = tr.find('.cellEditItem');
					for (var j = 0; j < tds.length; j++) {
						$(tds[j]).removeClass('cellEditItem')
					}
				}
			}
		}
	},
	/**
	 * 获得自定义过滤条件，供子类覆写使用
	 */
	getCustomFilterItems: function () {
		var parentId = shr.getUrlParam('parentId');
		var busDepIds = $("#busDep_el").val();
		var filter = "bonusCycle.id = '" + parentId + "' and bDPAPD.id is not null";
		if (busDepIds) {
			busDepIds = busDepIds.replace(/,/g, "','");
			return filter += " and busDep.id in ('" + busDepIds + "')";
		}
		return filter;
	},
	/**
	* 组装保存时传至服务端的数据
	*/
	assembleSaveData: function (action) {
		var _self = this;
		//组装需要修改的数据
		var data = [];
		var meta;
		var id, column, value, cur, element, personCode, datatype;
		var tds = $("#grid td[class*='dirty-cell']");
		var $table = $("#grid")[0];

		for (var i = 0; i < tds.length; i++) {
			//获取父节点，以获取对应id
			meta = {};
			var cur = $(tds[i]);
			//获取输入的内容，而不是转以后的字符实体，同时对单引号处理

			fid = cur.parent().attr('id');
			element = cur.attr('aria-describedby').replace('grid_', '');
			value = $($table).getCell(fid, element);
			//value = cur.text().replace(/\'/g, "''").trim();
			datatype = _self.getColumnType(element);
			if ("promptbox" == datatype) {
				column = element.split('.')[0];
				value = value["id"];
			} else {
				column = element.split('.')[1];
			}
			//列表需要显示id列
			id = $("#" + _self.getEscapeChars(fid) + " td[aria-describedby='grid_" + _self.getBillIdFieldName() + "']").attr('title');
			//校验
			_self.checkData(column, tds[i], value);
			// //校验输入内容
			if (!_self.checkNumValid(value, datatype)) {
				$(tds[i]).focus();
				$(tds[i]).css({
					"border": "solid 2px red"
				});
				throw new Error("请输入正确的格式");
			}
			meta.fid = id;
			meta.column = column;
			meta.value = value;
			meta.type = datatype;
			data.push(meta);
		}
		return data;
	},
	/**
	 * 
	 */
	checkData: function (column, td, value) {
		var _self = this;
		if ("bonusstartingdate" == column || "bonusduedate" == column) {
			//奖金期限开始日期  || 奖金期限截止日期
			var bonusstarting = $("#" + _self.getEscapeChars(fid) + " td[aria-describedby='grid_bdpapd.bonusstartingdate']")[0].innerText;
			var bonusdue = $("#" + _self.getEscapeChars(fid) + " td[aria-describedby='grid_bdpapd.bonusduedate']")[0].innerText;
			if (bonusstarting && bonusdue) {
				var bonusstartingdate = new Date(bonusstarting + ' 00:00:00')
				var bonusduedate = new Date(bonusdue + ' 00:00:00')
				if (bonusduedate < bonusstartingdate) {
					$(td).focus();
					$(td).css({
						"border": "solid 2px red"
					});
					throw new Error("奖金期限截止日期 不得早于 奖金期限开始日期");
				}
			}
		} else if ("person" == column && !value) {
			$(td).focus();
			$(td).css({
				"border": "solid 2px red"
			});
			throw new Error("分配人员不能为空!");
		}
	},
	/**
	 * 默认的action处理方法
	 */
	defaultBatchActionHandle: function (option) {
		var selectedIds = this.getSelectedIds();
		if (!selectedIds) {
			shr.showWarning({ message: "请先选中数据!", hideAfter: 3 })
			return;
		}
		shr.custom.DetailPrincipalDynamicList.superClass.defaultBatchActionHandle.call(this, option);
	},
	/**
	 * 计算
	 */
	calculateAction: function (option) {
		//设置过滤
		var fliter = this.getBusdepFilter();
		$("#calculateBusDep").shrPromptBox("setFilter", "id in ( " + fliter + ")");
		//打开
		$("#calculateBusDep").shrPromptBox("open");
	},
	/**
	* 真正的计算方法
	 */
	doCalculate: function () {
		var self = this;
		//事业部ids
		var busDepIds = $("#calculateBusDep_el").val();
		if (busDepIds) {
			var options = {
				action: 'calculate',
				uipk: this.uipk,
				type: 'POST',
				async: false,
				param: {
					busDepIds: busDepIds
				},
				success: function (res) {
					shr.showSuccess({ message: "成功!", hideAfter: 3 });
					self.queryGrid();
				},
				complete:function(jqXHR, textStatus){
					//清空选项
					$('#calculateBusDep').shrPromptBox("setValue", null);
				}
			};
			shr.remoteCall(options);
		} else {
			shr.showError({ message: "请先选中事业部", hideAfter: 3 });
		}
	},

	/**
	 * 提交
	*/
	submitAction: function (option) {
		//设置过滤
		var fliter = this.getBusdepFilter();
		$("#submitBusDep").shrPromptBox("setFilter", "id in ( " + fliter + ")");
		//打开
		$("#submitBusDep").shrPromptBox("open");
	},
	/**
	 * 真正的提交方法
	 */
	doSubmit: function () {
		var self = this;
		//事业部ids
		var busDepIds = $("#submitBusDep_el").val();
		if (busDepIds) {
			var options = {
				action: 'customSubmit',
				uipk: this.uipk,
				type: 'POST',
				async: false,
				param: {
					busDepIds: busDepIds
				},
				success: function (res) {
					shr.showSuccess({ message: "成功!", hideAfter: 3 });
					self.queryGrid();
				},
				complete:function(jqXHR, textStatus){
					//清空选项
					$('#submitBusDep').shrPromptBox("setValue", null);
				}
			};
			shr.remoteCall(options);
		} else {
			shr.showError({ message: "请先选中事业部", hideAfter: 3 });
		}

	},
	/**
	 * 获取事业部过滤条件
	 */
	getBusdepFilter: function (type) {
		var parentId = shr.getUrlParam('parentId');
		var fliter = "";
		if (!parentId) {
			shr.showError({ message: "parentId不能为空!", hideAfter: 3 });
			return fliter;
		}
		var options = {
			action: 'getBusDepIdStrByParentId',
			uipk: this.uipk,
			type: 'POST',
			async: false,
			param: {
				parentId: parentId,
				type: type
			},
			success: function (res) {
				fliter = res;
			},
		};
		shr.remoteCall(options);
		return fliter;
	},

});

