package com.kingdee.eas.custom.notify.app;

import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.notify.*;
import com.kingdee.eas.custom.notify.bziEnum.ReturnStateEnum;
import com.kingdee.eas.custom.notify.bziEnum.todoType;
import org.apache.log4j.Logger;

import java.lang.String;
import java.util.HashMap;
import java.util.Map;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.eas.custom.notify.notifyTodo.*;
import com.kingdee.util.StringUtils;

import java.io.*;
import java.lang.Exception;
import java.net.URL;
import java.util.Enumeration;
import java.util.Properties;

public class NotifyTodoControllerBean extends AbstractNotifyTodoControllerBean {
    private static Logger logger = Logger.getLogger(NotifyTodoControllerBean.class);
    private static Map maps = new HashMap();

    static {
        loadConfig();
    }

    /**
     * 
     */
    public static void loadConfig() {
        Properties props = new Properties();
        try {
            String propertiesUrl = System.getProperty("EAS_HOME") + "/server/properties/notifyTodo/propertie.properties";
            logger.debug("propertiesUrl:" + propertiesUrl);
            InputStream InputStream = new BufferedInputStream(new FileInputStream(new File(propertiesUrl)));
            props.load(InputStream);
        } catch (IOException var4) {
            var4.printStackTrace();
            logger.error("켯ɻȡļ: " + var4.getMessage());
        }
        Enumeration en = props.propertyNames();
        while (en.hasMoreElements()) {
            String key = (String) en.nextElement();
            String value = props.getProperty(key);
            maps.put(key, value);
            logger.debug(key + " : " + value);
        }
    }

    /**
     * ȡ
     *
     * @param key
     * @return
     */
    public static String getConfigValue(String key) {
        return (String) maps.get(key);
    }


    /**
     * ɾ
     *
     * @param ctx
     * @throws BOSException
     */
    @Override
    protected void _deleteTodo(Context ctx, RemoveContextInfo content)
            throws BOSException, EASBizException {
        String portAddress = getConfigValue("portAddress");
        if (StringUtils.isEmpty(portAddress)) {
            throw new BOSException("ɾӿڵַΪգļ/server/properties/notifyTodo/propertie.propertiesǷάportAddressԪ");
        }
        NotifyTodoAppResult result = null;
        try {
            ISysNotifyTodoWebServiceServiceLocator iSysNotifyTodoWebServiceServiceLocator = new ISysNotifyTodoWebServiceServiceLocator();
            URL url = new URL(portAddress);
            ISysNotifyTodoWebService iSysNotifyTodoWebServicePort = iSysNotifyTodoWebServiceServiceLocator.getISysNotifyTodoWebServicePort(url);
            NotifyTodoRemoveContext removeContext = new NotifyTodoRemoveContext((RemoveContextInfo) content);
            //ɾ
            result = iSysNotifyTodoWebServicePort.deleteTodo(removeContext);
            RemoveContextFactory.getLocalInstance(ctx).save(content);
            NotifyTodoInfo info = new NotifyTodoInfo();
            info.setTodoType(todoType.deleteTodo);
            info.setOperationType("ɾ");
            info.setSetdelTodoDone(content);
            ReturnStateEnum anEnum = ReturnStateEnum.getEnum(String.valueOf(result.getReturnState()));
            info.setReturnState(anEnum);
            info.setMessage(result.getMessage());
            save(ctx, info);
        } catch (Exception e) {
            e.printStackTrace();
            logger.error(e.getMessage());
            throw new BOSException(e);
        }
        if (result.getReturnState() != 2) {
            String message = result.getMessage();
            logger.error("OA켯״̬ " + result.getReturnState() + " : " + message);
            throw new BOSException(message);
        }
    }

    /**
     * ´
     *
     * @param ctx
     * @throws BOSException
     */
    @Override
    protected void _updateTodo(Context ctx, UpdateContentInfo content) throws BOSException {
        String portAddress = getConfigValue("portAddress");
        if (StringUtils.isEmpty(portAddress)) {
            throw new BOSException("´ӿڵַΪգļ/server/properties/notifyTodo/propertie.propertiesǷάportAddressԪ");
        }
        NotifyTodoAppResult result = null;
        try {
            ISysNotifyTodoWebServiceServiceLocator iSysNotifyTodoWebServiceServiceLocator = new ISysNotifyTodoWebServiceServiceLocator();
            URL url = new URL(portAddress);
            ISysNotifyTodoWebService iSysNotifyTodoWebServicePort = iSysNotifyTodoWebServiceServiceLocator.getISysNotifyTodoWebServicePort(url);
            NotifyTodoUpdateContext context = new NotifyTodoUpdateContext(content);
            //´
            result = iSysNotifyTodoWebServicePort.updateTodo(context);
            UpdateContentFactory.getLocalInstance(ctx).save(content);
            NotifyTodoInfo info = new NotifyTodoInfo();
            info.setTodoType(todoType.updateTodo);
            info.setOperationType(content.getSubject());
            info.setUpdateTodo(content);
            ReturnStateEnum anEnum = ReturnStateEnum.getEnum(String.valueOf(result.getReturnState()));
            info.setReturnState(anEnum);
            info.setMessage(result.getMessage());
            save(ctx, info);

        } catch (Exception e) {
            e.printStackTrace();
            logger.error(e.getMessage());
            throw new BOSException(e);
        }

        if (result.getReturnState() != 2) {
            String message = result.getMessage();
            logger.error("OA켯״̬ " + result.getReturnState() + " : " + message);
            throw new BOSException(message);
        }
    }

    /**
     * ΪѰ
     *
     * @param ctx
     * @throws BOSException
     */
    @Override
    protected void _setTodoDone(Context ctx, RemoveContextInfo content) throws BOSException {
        String portAddress = getConfigValue("portAddress");
        if (StringUtils.isEmpty(portAddress)) {
            throw new BOSException("ΪѰӿڵַΪգļ/server/properties/notifyTodo/propertie.propertiesǷάportAddressԪ");
        }

        NotifyTodoAppResult result = null;
        try {
            ISysNotifyTodoWebServiceServiceLocator iSysNotifyTodoWebServiceServiceLocator = new ISysNotifyTodoWebServiceServiceLocator();
            URL url = new URL(portAddress);
            ISysNotifyTodoWebService iSysNotifyTodoWebServicePort = iSysNotifyTodoWebServiceServiceLocator.getISysNotifyTodoWebServicePort(url);
            NotifyTodoRemoveContext context = new NotifyTodoRemoveContext(content);
            //ΪѰ
            result = iSysNotifyTodoWebServicePort.setTodoDone(context);
            //ɶӦ    OA켯
            RemoveContextFactory.getLocalInstance(ctx).save(content);
            NotifyTodoInfo info = new NotifyTodoInfo();
            info.setTodoType(todoType.setTodoDone);
            info.setOperationType("ΪѰ");
            info.setSetdelTodoDone(content);
            ReturnStateEnum anEnum = ReturnStateEnum.getEnum(String.valueOf(result.getReturnState()));
            info.setReturnState(anEnum);
            info.setMessage(result.getMessage());
            save(ctx, info);
        } catch (Exception e) {
            e.printStackTrace();
            logger.error(e.getMessage());
            throw new BOSException(e);
        }
        if (result.getReturnState() != 2) {
            String message = result.getMessage();
            logger.error("OA켯״̬ " + result.getReturnState() + " : " + message);
            throw new BOSException(message);
        }

    }


    /**
     * ʹ
     * http://eiptest.gemdale.com:8080/sys/webservice/sysNotifyTodoWebService
     * @param ctx
     * @throws BOSException
     */
    @Override
    protected void _sendTodo(Context ctx, SendContextInfo content) throws BOSException {
        String portAddress = getConfigValue("portAddress");
        if (StringUtils.isEmpty(portAddress)) {
            throw new BOSException("ʹӿڵַΪգļ/server/properties/notifyTodo/propertie.propertiesǷάportAddressԪ");
        }
        NotifyTodoAppResult result = null;
        try {
            ISysNotifyTodoWebServiceServiceLocator iSysNotifyTodoWebServiceServiceLocator = new ISysNotifyTodoWebServiceServiceLocator();
            URL url = new URL(portAddress);
            ISysNotifyTodoWebService iSysNotifyTodoWebServicePort = iSysNotifyTodoWebServiceServiceLocator.getISysNotifyTodoWebServicePort(url);
            NotifyTodoSendContext context = new NotifyTodoSendContext(content);
            //ʹ
            result = iSysNotifyTodoWebServicePort.sendTodo(context);
            //ɶӦ    OA켯
            SendContextFactory.getLocalInstance(ctx).save(content);
            NotifyTodoInfo info = new NotifyTodoInfo();
            info.setTodoType(todoType.sendTodo);
            info.setOperationType(content.getSubject());
            info.setSendTodo(content);
            ReturnStateEnum anEnum = ReturnStateEnum.getEnum(String.valueOf(result.getReturnState()));
            info.setReturnState(anEnum);
            info.setMessage(result.getMessage());
            save(ctx, info);
        } catch (Exception e) {
            e.printStackTrace();
            logger.error(e.getMessage());
            throw new BOSException(e);
        }
        if (result.getReturnState() != 2) {
            String message = result.getMessage();
            logger.error("OA켯״̬ " + result.getReturnState() + " : " + message);
            throw new BOSException(message);
        }
    }


}