package com.kingdee.eas.custom.projectbonus.web.service;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.basedata.org.AdminOrgUnitInfo;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.projectbonus.*;
import com.kingdee.eas.custom.projectbonus.bizEnum.BusDepProjectStateEnum;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.hr.ats.AtsUtil;
import com.kingdee.eas.util.app.ContextUtil;
import com.kingdee.shr.base.syssetting.app.io.fileImport.BaseColumnInfo;
import com.kingdee.shr.base.syssetting.app.io.fileImport.BaseImportService;
import com.kingdee.shr.base.syssetting.app.io.fileImport.BaseRowInfo;
import com.kingdee.shr.base.syssetting.app.io.fileImport.ImportException;
import com.kingdee.shr.ml.util.SHRServerResource;
import com.kingdee.util.StringUtils;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.math.BigDecimal;
import java.util.*;


/**
 * @Description Աϸбģ()_ݸµ
 * @Date 2024/5/7 21:28
 * @Created by Heyuan
 */
public class PrincipalDetailImportService extends BaseImportService {
    private final static SelectorItemCollection updateSic = new SelectorItemCollection();

    static {
        updateSic.add("initialProportion");//˳ʼ
        updateSic.add("functionCoefficient");//ְϵ
        updateSic.add("energyInputCoeff");//Ͷϵ
        updateSic.add("performanceGradeQ1");//Q1Чȼ
        updateSic.add("performanceGradeQ2");//Q2Чȼ
        updateSic.add("performanceCoeffQ1");//Q1Чϵ
        updateSic.add("performanceCoeffQ2");//Q2Чϵ
        updateSic.add("bonusStartingDate");//
        updateSic.add("bonusDueDate");//޽ֹ
        updateSic.add("remarks");//ע
        updateSic.add("opinionAmount");//
    }

    /**
     * ģʱЯ
     *
     * @param columnInfoMap
     * @param wb
     * @param sheet
     */
    @Override
    public void completeGenerateExcel(Map<String, BaseColumnInfo> columnInfoMap,
                                      XSSFWorkbook wb,
                                      XSSFSheet sheet) {
        Context ctx = this.getContext();
        String parentId = this.getCustomParam("parentId");
        String busDepIds = this.getCustomParam("busDepIds");
        if (StringUtils.isEmpty(parentId)) {
            throw new RuntimeException("ҵĿݵģ屨,parentIdΪ!");
        }
        int beginRow = 4;//ɿʼ
        //صһ
        //sheet.setColumnHidden(0, true);
        try {
            IBonusCycleBusDepProjectAssPersonnelDetail iBonusCycleBusDepProjectAssPersonnelDetail =
                    BonusCycleBusDepProjectAssPersonnelDetailFactory.getLocalInstance(ctx);
            //ǰ¼
            PersonInfo personInfo = ContextUtil.getCurrentUserInfo(ctx).getPerson();
            String personId = personInfo.getId().toString();
            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("*");
            sic.add("person.name");
            sic.add("person.number");
            sic.add("parent.*");
            sic.add("parent.busDep.name");
            sic.add("parent.busDep.number");
            sic.add("parent.project.name");
            sic.add("parent.project.number");
            sic.add("parent.parent.cycleName");
            //
            FilterInfo filterInfo = new FilterInfo();
            FilterItemCollection filterItems = filterInfo.getFilterItems();
            filterItems.add(new FilterItemInfo("parent.parent.id", parentId));
            filterItems.add(new FilterItemInfo("parent.principal", personId));
            filterItems.add(new FilterItemInfo("parent.state", 1));
            if (!StringUtils.isEmpty(busDepIds)) {
                //ҵid
                Set<String> depIdSet = AtsUtil.toSet(busDepIds);
                filterItems.add(new FilterItemInfo("parent.busDep", depIdSet, CompareType.INCLUDE));
            }
            SorterItemCollection sorterItemCollection = new SorterItemCollection();
            sorterItemCollection.add(new SorterItemInfo("parent.parent.id"));
            sorterItemCollection.add(new SorterItemInfo("parent.id"));
            EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, sorterItemCollection);
            //Աϸ
            BonusCycleBusDepProjectAssPersonnelDetailCollection personnelDetailCols =
                    iBonusCycleBusDepProjectAssPersonnelDetail.getBonusCycleBusDepProjectAssPersonnelDetailCollection(entityViewInfo);
            Map<Integer, String> columnIndexMap = this.getColumnIndexFn(columnInfoMap);
            int fillColumnCount = columnInfoMap.size();
            for (int i = 0; i < personnelDetailCols.size(); i++) {
                Row row = sheet.createRow(i + beginRow);
                BonusCycleBusDepProjectAssPersonnelDetailInfo info = personnelDetailCols.get(i);
                //ҵĿ
                BonusCycleBusDepProjectInfo depProjectInfo = info.getParent();
                //Ϣ
                BonusCycleInfo bonusCycleInfo = depProjectInfo.getParent();
                for (int j = 0; j < fillColumnCount; ++j) {
                    Cell createCell = row.createCell(j);
                    String columnName = columnIndexMap.get(j);
                    String value = null;
                    CoreBaseInfo coreBase = null;
                    if (columnName.startsWith("BonusCycle.")) {
                        columnName = columnName.substring(columnName.indexOf(".") + 1);
                        coreBase = bonusCycleInfo;
                    } else if (columnName.startsWith("BonusCycleBusDepProject.")) {
                        columnName = columnName.substring(columnName.indexOf(".") + 1);
                        coreBase = depProjectInfo;
                    } else {
                        coreBase = info;
                    }
                    Object obj = coreBase.get(columnName);
                    if (obj != null) {
                        if (obj instanceof CoreBaseInfo) {
                            CoreBaseInfo coreBaseInfo = (CoreBaseInfo) coreBase.get(columnName);
                            value = coreBaseInfo.get("number") + "##" + coreBaseInfo.get("name");
                        } else if (obj instanceof BigDecimal) {
                            BigDecimal bigDecimal = (BigDecimal) obj;
                            value = bigDecimal.setScale(2).toPlainString();
                        } else {
                            value = obj.toString();
                        }
                    }
                    createCell.setCellValue(value);
                }
            }
        } catch (BOSException var33) {
            if (var33.getMessage().contains("fetched too much rows")) {
                throw new ImportException("ѯƣϵϵͳԱ޸ã߼ص");
            } else {
                var33.printStackTrace();
                throw new ImportException("ģʧ", var33);
            }
        } catch (Exception var35) {
            var35.printStackTrace();
            throw new ImportException("ģʧ", var35);
        }
    }

    /**
     * ȡַ
     *
     * @param row
     * @return
     */
    @Override
    protected String getPKSelectString(BaseRowInfo row) {
        List<BaseColumnInfo> keyColumnList = row.getKeyColumnInfo();
        for (int i = 0; i < keyColumnList.size(); ++i) {
            BaseColumnInfo keyColumn = keyColumnList.get(i);
            keyColumn.setCustomField(false);
        }
        return super.getPKSelectString(row);
    }

    /**
     * ֶ
     *
     * @param baseInfo
     * @param row
     * @throws ImportException
     */
    protected void setOtherFieldInfo(CoreBaseInfo baseInfo, BaseRowInfo row) throws ImportException {
        try {
            BonusCycleBusDepProjectAssPersonnelDetailInfo info = (BonusCycleBusDepProjectAssPersonnelDetailInfo) baseInfo;
            String id = info.getId().toString();
            Context ctx = this.getContext();
            IBonusCycleBusDepProjectAssPersonnelDetail localInstance = BonusCycleBusDepProjectAssPersonnelDetailFactory.getLocalInstance(ctx);

            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("parent.busDep.name");
            sic.add("parent.project.name");
            sic.add("parent.principal.id");
            sic.add("parent.state");
            //Աϸ
            BonusCycleBusDepProjectAssPersonnelDetailInfo personnelDetailInfo =
                    localInstance.getBonusCycleBusDepProjectAssPersonnelDetailInfo(new ObjectUuidPK(id), sic);
            BonusCycleBusDepProjectInfo parent = personnelDetailInfo.getParent();
            info.setParent(parent);
        } catch (Exception e) {
            e.printStackTrace();
            throw new ImportException(e.getMessage());
        }
    }

    /**
     * У
     *
     * @param coreBaseInfo
     * @throws ImportException
     */
    protected void verifyRowBiz(CoreBaseInfo coreBaseInfo) throws ImportException {
        BonusCycleBusDepProjectAssPersonnelDetailInfo info = (BonusCycleBusDepProjectAssPersonnelDetailInfo) coreBaseInfo;
        BonusCycleBusDepProjectInfo parent = info.getParent();
        //ҵ״̬
        BusDepProjectStateEnum state = parent.getState();
        //
        PersonInfo principal = parent.getPrincipal();
        StringBuilder errorMsg = new StringBuilder();
        AdminOrgUnitInfo project = parent.getProject();
        if (project != null) {
            String projectName = project.getName();
            errorMsg.append("Ŀ[").append(projectName);
        } else {
            String busDepName = parent.getBusDep().getName();
            errorMsg.append("ҵ[").append(busDepName);
        }
        if (!BusDepProjectStateEnum.ENABLE.equals(state)) {
            errorMsg.append("]״̬޸");
            throw new ImportException(errorMsg.toString());
        }
        Context ctx = this.getContext();
        //ǰ¼
        PersonInfo personInfo = ContextUtil.getCurrentUserInfo(ctx).getPerson();
        String personId = personInfo.getId().toString();
        if (!personId.equals(principal.getId().toString())) {
            errorMsg.append("]ĸ˲ǵǰˣ޸");
            throw new ImportException(errorMsg.toString());
        }
    }

    /**
     * ύ
     *
     * @param coreBaseInfo
     * @throws ImportException
     */
    @Override
    protected void submitData(CoreBaseInfo coreBaseInfo) throws ImportException {
        ImportException importException;
        try {
            IBonusCycleBusDepProjectAssPersonnelDetail iBonusCycleBusDepProjectAssPersonnelDetail =
                    BonusCycleBusDepProjectAssPersonnelDetailFactory.getLocalInstance(this.getContext());
            iBonusCycleBusDepProjectAssPersonnelDetail.updatePartial(coreBaseInfo, updateSic);
        } catch (EASBizException var4) {
            importException = new ImportException(var4.getMessage(this.getContext().getLocale()), var4);
            throw importException;
        } catch (BOSException var5) {
            importException = new ImportException(SHRServerResource.getString("com.kingdee.shr.base.syssetting.CommonserviceResource", "save_fails_bos", this.getContext()), var5);
            throw importException;
        } catch (Exception var6) {
            importException = new ImportException(SHRServerResource.getString("com.kingdee.shr.base.syssetting.CommonserviceResource", "save_submit_fails", this.getContext()), var6);
            throw importException;
        }
    }

    /**
     * жתMap
     *
     * @param columnInfoMap
     * @return
     */
    protected Map<Integer, String> getColumnIndexFn(Map<String, BaseColumnInfo> columnInfoMap) {
        Map<Integer, String> columnIndexMap = new HashMap();
        Iterator<String> keys = columnInfoMap.keySet().iterator();
        int var4 = 0;
        while (keys.hasNext()) {
            String key = keys.next();
            columnIndexMap.put(var4++, key);
        }
        return columnIndexMap;
    }
}
